#include <Rcpp.h>
#include <math.h>
#include <cmath>
#include <Rmath.h>

// [[Rcpp::plugins("cpp17")]]

// [[Rcpp::export]]

double dvm(double theta, double mu, double kappa){
  double p;
  if(kappa<1000){
    p = exp(kappa*cos(theta-mu))/(2*M_PI*R::bessel_i(kappa, 0, 0));
  } else{
    p=0;
  }
  return p;
}
